> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gomaestro.org/llms.txt
> Use this file to discover all available pages before exploring further.

> Get Bitcoin Runes activity history for an address including mints, transfers, and burns.

# Rune Activity by Address



## OpenAPI

````yaml bitcoin/blockchain-indexer-api/openapi.json get /addresses/{address}/runes/activity
openapi: 3.0.3
info:
  title: Bitcoin - Blockchain Indexer API
  description: >-
    This API provides core indexer endpoints with support for Bitcoin
    metaprotocols by delivering real-time, rollback-protected access to
    Bitcoin's UTXO data, enabling developers to build responsive and reliable
    blockchain applications without managing complex infrastructure.


    #### Key Features:

    - **Real-Time Data with Rollback Protection:** Ensures data accuracy by
    handling chain reorganizations gracefully, providing live data without
    sacrificing integrity.

    - **Comprehensive UTXO Indexing:** Specialized pipelines extract, match, and
    process on-chain information, including handling rollbacks, to provide
    accurate and up-to-date data.


    #### Key Benefits for Developers:

    By abstracting the complexities of blockchain data retrieval and processing,
    Maestro's Bitcoin Indexer API empowers developers to focus on building
    innovative applications with confidence in fast and reliable access to
    historical chain data.
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.txt
  version: v0.2.0
servers:
  - url: https://xbt-mainnet.gomaestro-api.org/v0
    description: Bitcoin Mainnet
  - url: https://xbt-testnet.gomaestro-api.org/v0
    description: Bitcoin Testnet
security:
  - api-key: []
paths:
  /addresses/{address}/runes/activity:
    get:
      tags:
        - Addresses
      summary: Rune Activity by Address
      description: >-
        Return all transactions where the specified address has rune activity,
        with the option to filter by a specific rune kind.
      operationId: rune_activity_by_address
      parameters:
        - name: address
          in: path
          description: Bitcoin address or hex encoded script pubkey
          required: true
          schema:
            type: string
          example: bc1p27j3fa2mr3d50m3uaavr0ntyzr0v2a27n48lc9gxpkzd4xye6dgs2tzx6p
        - name: order
          in: query
          description: >-
            The order in which the results are sorted. Supported values: asc,
            desc
          required: false
          schema:
            allOf:
              - type: string
                default: asc
                enum:
                  - asc
                  - desc
            nullable: true
        - name: count
          in: query
          description: The max number of results per page
          required: false
          schema:
            allOf:
              - type: integer
                default: 100
                minimum: 0
            nullable: true
        - name: from
          in: query
          description: Return only transactions created on or after a specific height
          required: false
          schema:
            type: integer
            format: int64
            nullable: true
            minimum: 0
        - name: to
          in: query
          description: Return only transactions created on or before a specific height
          required: false
          schema:
            type: integer
            format: int64
            nullable: true
            minimum: 0
        - name: cursor
          in: query
          description: >-
            Pagination cursor string, use the cursor included in a page of
            results to fetch the next page
          required: false
          schema:
            type: string
            nullable: true
        - name: rune
          in: query
          description: >-
            Return only transactions containing a specific rune, specified
            either by the rune ID (etching block number and transaction index)
            or name (spaced or un-spaced). In presence of activity_kind, it
            relates to this specific rune. In presence of
            exclude_self_transfers, it is this specific rune that the queried
            address should see increase or decrease in balance in the tx, not
            just being self-transferred.
          required: false
          schema:
            type: string
            nullable: true
          example: '840000:3'
        - name: activity_kind
          in: query
          description: >-
            Filter txs by presence specific activity kind. Supported values:
            increased, decreased, self_transfer. In presence of rune filter, the
            activity kind relates to that specific rune. In presence of
            exclude_self_transfers, this activity kind cannot be self_transfer.
          required: false
          schema:
            allOf:
              - $ref: '#/components/schemas/RuneActivityKindByAddress'
            nullable: true
        - name: exclude_self_transfers
          in: query
          description: >-
            Exclude txs only containing runes self-transfers. In presence of
            activity_kind, it cannot be self_transfer. In presence of rune
            filter, that specific rune should be sent or received, not
            self-transferred.
          required: false
          schema:
            type: boolean
            nullable: true
      responses:
        '200':
          description: Requested data
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedRuneActivityByAddress'
              example:
                data:
                  - confirmations: 21684
                    decreased_balances: []
                    etched_rune: null
                    height: 875944
                    increased_balances:
                      - amount: '1453573'
                        rune_id: '840000:28'
                    minted: null
                    self_transfers: []
                    tx_hash: >-
                      6a4237d43719e0766a8333eb8531b3bae9b20e7484e6962a731773b883315da1
                  - confirmations: 21558
                    decreased_balances: []
                    etched_rune: null
                    height: 876070
                    increased_balances: []
                    minted: null
                    self_transfers:
                      - amount: '1453573'
                        rune_id: '840000:28'
                    tx_hash: >-
                      1c2c45980432108fda7b4eb2a390bd1cae7aac62b9309f5ef3911960e50b8501
                  - confirmations: 21525
                    decreased_balances:
                      - amount: '207654'
                        rune_id: '840000:28'
                    etched_rune: null
                    height: 876103
                    increased_balances: []
                    minted: null
                    self_transfers: []
                    tx_hash: >-
                      cbcbac069d142c303b062dda88635e4939d69120f66d89a9da17ebd0ff806a1f
                last_updated:
                  block_hash: >-
                    0000000000000000000119bd8dffd7d8285a69744011aa98f0d9091b0555ca46
                  block_height: 897627
                next_cursor: null
        '400':
          description: Malformed query parameters
        '404':
          description: Requested entity not found on-chain
        '500':
          description: Internal server error
components:
  schemas:
    RuneActivityKindByAddress:
      type: string
      enum:
        - self_transfer
        - increase
        - decrease
    PaginatedRuneActivityByAddress:
      type: object
      required:
        - data
        - last_updated
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/RuneActivityByAddress'
        last_updated:
          $ref: '#/components/schemas/ChainTip'
        next_cursor:
          type: string
          nullable: true
    RuneActivityByAddress:
      type: object
      required:
        - height
        - confirmations
        - tx_hash
        - rune_activity
      properties:
        confirmations:
          type: integer
          format: int64
          description: Number of confirmation blocks.
          minimum: 0
        height:
          type: integer
          format: int64
          description: Height of block containing the rune activity.
          minimum: 0
        rune_activity:
          $ref: '#/components/schemas/RuneActivity'
        tx_hash:
          type: string
          description: Hash of transaction containing the rune activity.
    ChainTip:
      type: object
      required:
        - block_hash
        - block_height
      properties:
        block_hash:
          type: string
          description: The hash of the block
          example: 0000000000000000000a7f3b7b6b6e1d9a18db65a3b4a3f4f3bcb2e1f1b2d3e7
        block_height:
          type: integer
          format: int64
          description: The height of the block in the blockchain
          example: 707000
          minimum: 0
    RuneActivity:
      type: object
      required:
        - self_transfers
        - increased_balances
        - decreased_balances
      properties:
        decreased_balances:
          type: array
          items:
            $ref: '#/components/schemas/RuneAndAmount'
          description: >-
            List of runes and amounts, corresponding to decreased balances for
            this address.
        etched_rune:
          allOf:
            - $ref: '#/components/schemas/EtchAndPremine'
          nullable: true
        increased_balances:
          type: array
          items:
            $ref: '#/components/schemas/RuneAndAmount'
          description: >-
            List of runes and amounts, corresponding to increased balances for
            this address.
        minted:
          allOf:
            - $ref: '#/components/schemas/RuneAndAmount'
          nullable: true
        self_transfers:
          type: array
          items:
            $ref: '#/components/schemas/RuneAndAmount'
          description: List of runes that were self-transferred.
    RuneAndAmount:
      type: object
      required:
        - rune_id
        - amount
      properties:
        amount:
          type: string
        rune_id:
          type: string
    EtchAndPremine:
      type: object
      required:
        - rune_id
      properties:
        premined_amount:
          type: string
          description: Amount of premined runes.
          nullable: true
        rune_id:
          type: string
          description: Rune ID.
  securitySchemes:
    api-key:
      type: apiKey
      in: header
      name: api-key
      description: Project API Key

````